Imports System.Drawing

Public Class PFMain
    Inherits System.Windows.Forms.Form
    Dim GFX As Graphics  'Draws to the backbuffer.
    Dim FormGFX As Graphics  ' Draws to the form.

    Dim Backbuffer As Bitmap    'Empty bitmap.

    Dim PlayerBmp As Bitmap           'This will hold the main character graphics.
    'Actually, it is a bunch of frames of the character.

    Dim PlayerLoc As Rectangle
    'This will hold the current location of the player.  X and Y included.
    'Why didn't I use point?  Because I am probably going to use the height and width for collisions later.
    Dim GoLeft, GoRight, GoFast As Boolean
    'Indicates which buttons are pressed.
    Dim CharDirec As Integer
    'Which direction is the character facing?
    Dim AnimCycler As Integer
    'This is the animation cycler that will count from 0 to 3 and back to 0.
    Dim IsJumping As Boolean
    'While this is true, the character will be jumping.
    Dim PlayerVeloc As Integer
    'This is the velocity of the player in the Y direction.
    'Positive values point down.
    'To jump up, PlayerVeloc must be initialized to a negative value.
    Dim GoDown As Boolean
    'Indicates if the down arrow is pressed.
    Dim Platform As Rectangle
    'A platform.
    Dim LeftEnd As Integer
    Dim RightEnd As Integer
    'This stores the locations of the end of the cliff that the character is currently on.
    Dim Platforms As ArrayList
    'This will store the platforms that are in this level.
    Dim Coin As Rectangle
    'This holds the location of the coin.
    Dim CoinBmp As Bitmap
    'This contains the frames of the coin as it will be drawn onto the map.
    Dim Wall As Rectangle
    'Holds the location of the wall.

    Const MAPWIDTH As Integer = 800
    Const MAPHEIGHT As Integer = 600
    'I need to determine a default spot for my land.
    'It has to be between 0 and MAPHEIGHT, since that's the height of my backbuffer.
    'Preferably closer to 600 as more land equals less playing area.
    Const LANDHEIGHT As Integer = 568
    '600 - 32 = 568... I like 32. 
    'Constants are good for you.
    Const CHARWIDTH As Integer = 16
    Const CHARHEIGHT As Integer = 32
    'These define the width of the character in the file.

    Const MOVESPEED As Integer = 5
    'How much I move every tick
    Const WALKINGFRAMECOUNT As Integer = 4
    'How many frames are in each walking cycle.
    Const SBARINITIALVELOCITY As Integer = -32
    'The initial velocity for the player's jump using space bar.
    Const GRAVITY As Integer = 4
    'Gravitational acceleration constant... how much the speed changes at each tick.
    Const LOWJUMPVELOCITY As Integer = -10
    'Initial velocity for a low jump.
    Const SHOULDER As Integer = 17
    'Looked in paint to determine the distance the shoulder is from the bottom of the foot.
    'This will be used for determining if the player gets on a platform.
    Const COINSIZE As Integer = 16
    'The width and height of the coin.
    Const COINFRAMECOUNT As Integer = 4
    'The number of frames in the coin bitmap.

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Clock As System.Windows.Forms.Timer
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.Clock = New System.Windows.Forms.Timer(Me.components)
        '
        'Clock
        '
        Me.Clock.Enabled = True
        '
        'PFMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(520, 381)
        Me.Name = "PFMain"
        Me.Text = "Platform Tour"

    End Sub

#End Region

    Private Sub PFMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Setup our clock interval.
        Clock.Interval = 100
        Clock.Enabled = True

        Me.Size = New Size(MAPWIDTH + 8, MAPHEIGHT + 24)

        'Create the backbuffer.  This will hold the map information... what you actually will see, because I
        'am going to draw it to the form in one fell swoop.  Just that I'm going to be drawing onto the backbuffer
        'for all of my miscellaneous artworks, and then draw everything that I accumulated onto this backbuffer to the
        'form. :)
        Backbuffer = New Bitmap(MAPWIDTH, MAPHEIGHT)
        'GFX is aimed at the backbuffer.
        GFX = Graphics.FromImage(Backbuffer)
        'FormGFX is aimed at the form.
        FormGFX = Me.CreateGraphics()

        LeftEnd = 0 : RightEnd = MAPWIDTH
        'Set the current end points.

        Coin = New Rectangle(200, 550, COINSIZE, COINSIZE)
        CoinBmp = New Bitmap(Application.StartupPath & "\..\coin.bmp")
        'Initialize the coin location and picture.
        CoinBmp.MakeTransparent(Color.Magenta)
        'Clears the magenta colors in this bitmap.


        Platforms = New ArrayList(3)
        'Initialize/instantiate the platforms arraylist.
        Platforms.Add(Rectangle.FromLTRB(50, 415, 160, LANDHEIGHT))
        Platforms.Add(Rectangle.FromLTRB(100, 465, 185, LANDHEIGHT))
        Platforms.Add(Rectangle.FromLTRB(150, 515, 210, LANDHEIGHT))
        'Create three platforms.
        Wall = Rectangle.FromLTRB(185, 415, 210, 465)
        'Wall is initialized.

        PlayerBmp = New Bitmap(Application.StartupPath & "\..\sumult.bmp")
        'Loads the image into this bitmap.
        'Given this arrangement, the bitmap must be in the same directory as the solution.
        PlayerBmp.MakeTransparent(Color.Magenta)
        'Makes all of the magenta in the bitmap transparent.

        PlayerLoc = New Rectangle(100, LANDHEIGHT - CHARHEIGHT, CHARWIDTH, CHARHEIGHT)
        'Instantiate the player location.
    End Sub

    Private Sub Clock_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Clock.Tick

        Me.CharacterMovement()
        'Handles the character movement.
        Me.Artwork()
        'Draws the information to the backbuffer, and then, to the form.

    End Sub

    Private Sub DrawOnForm()
        FormGFX.DrawImage(Backbuffer, 0, 0)
        'The backbuffer was drawn on by the GFX.
    End Sub

    Private Sub PFMain_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        If e.KeyCode = Keys.Left Then
            GoLeft = True
        ElseIf e.KeyCode = Keys.Right Then
            GoRight = True
        ElseIf e.KeyCode = Keys.ShiftKey Then
            GoFast = True
        ElseIf e.KeyCode = Keys.Down Then
            GoDown = True
        ElseIf e.KeyCode = Keys.Space Then
            IsJumping = True
            'The jump is initialized.
            If GoDown Then
                PlayerVeloc = Me.LOWJUMPVELOCITY
                'Use low jump velocity if down is pressed.
            Else
                PlayerVeloc = Me.SBARINITIALVELOCITY
                'Use space bar initial velocity.

            End If
        End If
    End Sub

    Private Sub PFMain_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp
        If e.KeyCode = Keys.Left Then
            GoLeft = False
        ElseIf e.KeyCode = Keys.Right Then
            GoRight = False
        ElseIf e.KeyCode = Keys.ShiftKey Then
            GoFast = False
        ElseIf e.KeyCode = Keys.Down Then
            GoDown = False
        End If

        If Not (GoLeft OrElse GoRight) Then
            'If neither key is pressed.
            AnimCycler = 0
            'Reset the counter, and signal another redraw.
        End If

    End Sub

    Private Sub CharacterMovement()
        Dim Collisres As Integer
        'Holds the result of the QuadContact function.

        If GoLeft Then
            If GoFast Then
                PlayerLoc.Offset(-MOVESPEED - (MOVESPEED >> 1), 0)
                'When Shift is pressed the player runs.
                'Runs to the left.
            Else
                PlayerLoc.Offset(-MOVESPEED, 0)
                'Move player left.

            End If
            If PlayerLoc.Left < 0 Then
                'If the player goes off the edge of the form, then we will move him back to the edge.
                PlayerLoc.Offset(-PlayerLoc.Left, 0)
            ElseIf PlayerLoc.Right < LeftEnd AndAlso Not IsJumping Then
                IsJumping = True
                'We are not really jumping, but we are falling.
                PlayerVeloc = 0
                'Since we are falling from rest, the initial velocity will be zero.
            ElseIf PlayerLoc.IntersectsWith(Wall) Then
                PlayerLoc.Offset(Wall.Right - PlayerLoc.Left, 0)
                'Move the player to the edge of this wall.
            End If
            CharDirec = 0   'Look left.
            'Now, update the animation cycler.
            AnimCycler = (AnimCycler + 1) Mod WALKINGFRAMECOUNT
        ElseIf GoRight Then
            If GoFast Then
                PlayerLoc.Offset(MOVESPEED + (MOVESPEED >> 1), 0)
                'Runs to the right.
            Else
                PlayerLoc.Offset(MOVESPEED, 0)
                'Move player right.

            End If
            If PlayerLoc.Right > MAPWIDTH Then
                'If player goes off right edge... move him back.
                PlayerLoc.Offset(MAPWIDTH - PlayerLoc.Right, 0)
            ElseIf PlayerLoc.Left > RightEnd AndAlso Not IsJumping Then
                IsJumping = True
                'We are falling.
                PlayerVeloc = 0
                'A fall from rest.
            ElseIf PlayerLoc.IntersectsWith(Wall) Then
                PlayerLoc.Offset(Wall.Left - PlayerLoc.Right, 0)
                'Move the player to the edge of this wall.
            End If
            CharDirec = 1   'Look right.
            'Now, update the animation cycler.
            AnimCycler = (AnimCycler + 1) Mod WALKINGFRAMECOUNT
        End If

        If IsJumping Then
            PlayerLoc.Offset(0, PlayerVeloc + GRAVITY >> 1)
            'dD (.OffSet) = Vo (PlayerVeloc) + 0.5 * A (GRAVITY >> 1)
            PlayerVeloc += GRAVITY
            'dV = (PlayerVeloc +=) A (GRAVITY)
            'Moves the character according to its velocity, gravity, and location.
            If PlayerLoc.Bottom >= Me.LANDHEIGHT Then
                'Check if we are touching the ground (another RECT advantage).

                IsJumping = False
                'Stop the jump: we have hit the ground.
                LeftEnd = 0 : RightEnd = MAPWIDTH
                'Set the endpoints for the ground.
                AnimCycler = 0
                'Reset the animation cycler: it has been counting during the jump.
                PlayerLoc.Offset(0, LANDHEIGHT - PlayerLoc.Bottom)
                'Move the player to stand on the land properly.
            Else
                For Each Platform In Platforms
                    'Looking at each platform in the platform array.
                    If PlayerVeloc > 0 AndAlso PlayerLoc.Bottom >= Platform.Top AndAlso PlayerLoc.Bottom - SHOULDER <= Platform.Top Then
                        If PlayerLoc.Left < Platform.Right AndAlso PlayerLoc.Right > Platform.Left Then
                            'The player has landed on this platform.  He needs to be updated.
                            'See how many advantages there are to using a Rectangle.

                            IsJumping = False
                            'Hit the ground, we are not jumping.
                            LeftEnd = Platform.Left : RightEnd = Platform.Right
                            'Set the endpoints for the platform.
                            AnimCycler = 0
                            'Reset cycler.
                            PlayerLoc.Offset(0, Platform.Top - PlayerLoc.Bottom)
                            'Move the player onto this platform.
                        End If
                    End If
                Next

                If PlayerLoc.IntersectsWith(Wall) Then
                    If PlayerVeloc > 0 Then
                        'If player is falling, then the player will land on the wall.
                        IsJumping = False
                        'Stop the jump.
                        LeftEnd = Wall.Left : RightEnd = Wall.Right
                        'Set the endpoints.
                        AnimCycler = 0
                        'Reset the cycler.
                        PlayerLoc.Offset(0, Wall.Top - PlayerLoc.Bottom)
                        'Position the player to stand on this wall.
                    Else
                        'The player has jumped up into the wall.
                        PlayerLoc.Offset(0, Wall.Bottom - PlayerLoc.Top)
                        'Move the player to under the wall.
                        PlayerVeloc = 0
                        'Make the player start falling down.
                    End If
                End If
            End If
        End If

        If Coin.IntersectsWith(PlayerLoc) Then
            Coin = Coin.Empty
            'Make the coin rectangle empty to indicate that we do not need to draw it.
        End If
    End Sub



    Private Sub Artwork()
        Static Anim As Integer
        'Holds a number that coordinates animations.
        Anim += 1
        'Increment the counter.

        'I am going to draw a lightblue rectangle for the sky.
        'It will go down until it reaches the land, so therefore the bottom of the rectangle has to be
        'the LANDHEIGHT.
        GFX.FillRectangle(Brushes.LightSkyBlue, Rectangle.FromLTRB(0, 0, MAPWIDTH, LANDHEIGHT))
        'And the remainder of the area is LAND, starting from LANDHEIGHT.
        GFX.FillRectangle(Brushes.ForestGreen, Rectangle.FromLTRB(0, LANDHEIGHT, MAPWIDTH, MAPHEIGHT))
        'I use LTRB instead of New so that I don't have to calculate the height.
        'These two will make the 'background' for the form.
        For Each Platform In Platforms
            'Loop through each platform in the arraylist.
            GFX.FillRectangle(Brushes.Tan, Platform)
            GFX.DrawRectangle(Pens.RosyBrown, Platform)
            'I'm not into interior decorating, so the only thing I can say about these colors is that 
            'they'd better be a light brown persuasion.  This draws the platform.
        Next
        GFX.FillRectangle(Brushes.Chocolate, Wall)
        GFX.DrawRectangle(Pens.BurlyWood, Wall)
        'This will draw the wall onto the form.

        If IsJumping Then
            GFX.DrawImage(PlayerBmp, PlayerLoc.X, PlayerLoc.Y, New Rectangle((CHARWIDTH * WALKINGFRAMECOUNT << 1) + CharDirec * CHARWIDTH, 0, CHARWIDTH, CHARHEIGHT), GraphicsUnit.Pixel)
            'Jumping draw only.
        Else
            GFX.DrawImage(PlayerBmp, PlayerLoc.X, PlayerLoc.Y, New Rectangle(CHARWIDTH * CharDirec * WALKINGFRAMECOUNT + AnimCycler * CHARWIDTH, 0, CHARWIDTH, CHARHEIGHT), GraphicsUnit.Pixel)
            'This draws the character to the display, based on the current character location, frame, and state.
        End If

        If Not Coin.IsEmpty Then
            GFX.DrawImage(CoinBmp, Coin.X, Coin.Y, New Rectangle((Anim Mod COINFRAMECOUNT) * COINSIZE, 0, COINSIZE, COINSIZE), GraphicsUnit.Pixel)
            'Draws our spinning coin onto the form.
        End If

        Me.DrawOnForm()
        'Me.Invalidate(New Rectangle(0, 0, 1, 1))
    End Sub

    Public Shared Function QuadContact(ByVal Domain As Rectangle, ByVal Probe As Rectangle) As Integer
        'Domain is the wall.  E1 is the player.
        Dim M1 As Single
        Dim B1 As Single
        'Data for L line.
        Dim M2 As Single
        Dim B2 As Single
        'Data for R line.
        Dim Xm As Single
        Dim Ym As Single
        Dim UR As Boolean, UL As Boolean
        M1 = -Convert.ToSingle(Domain.Height / Domain.Width)
        'M1 is the slope of the up-left horizontal line.
        B1 = ((Domain.Bottom) - M1 * Domain.Left)
        'B1 is the top-intercept of the up-left horizontal line.
        M2 = -M1
        'The R line has a slope that is opposite of the up-left horizontal line.
        B2 = Domain.Top - M2 * Domain.Left
        'And that is its top-intercept.
        Xm = Probe.Left + Probe.Width \ 2
        Ym = Probe.Top + Probe.Height \ 2
        'This is the center of the dog.
        If Ym <= (M1 * Xm) + B1 Then UL = True
        'This first check is to check if the dog's center is above the up-left horizontal line.
        If Ym <= (M2 * Xm) + B2 Then UR = True
        'This check is for dog's center and the up-right horizontal line.
        If UL And UR Then
            'If it's above both lines, then it's at the top.
            If Probe.Bottom >= Domain.Top Then QuadContact = 2
            'The if statement checks collision... at this point, we have determined that
            'the object is above the center of the shape, we only need to check if it is
            'touching the shape, now.
        ElseIf UL Then
            'Above the up-left horizontal line and not the up-right horizontal line means that it crosses on the left.
            If Probe.Right >= Domain.Left Then QuadContact = 1
        ElseIf UR Then
            'Above the up-right horizontal line and not the up-left horizontal line means that it crosses on the right.
            If Probe.Left <= Domain.Right Then QuadContact = 3
        Else
            'Not crossing either line; crosses on the bottom.
            If Probe.Top <= Domain.Bottom Then QuadContact = 4
        End If
    End Function
End Class
